"use strict";
this.name        = "reversecontrol";
this.author      = "Norby";
this.copyright   = "2014 Norbert Nagy";
this.licence     = "CC BY-NC-SA 3.0";
this.description = "Reverse up-down control in the aft view.";
this.version     = "1.3";

//customizable properties
this.$ReverseControlOn = true; //can turn off without uninstall

//internal properties, should not touch
this.$ReverseControlFCB = null; //FrameCallBack
this.$ReverseControlPrevOri = null; //previous orientation

//world script events
this.startUp = function() {
	if( this.$ReverseControlOn && !isValidFrameCallback( this.$ReverseControlFCB ) )
		this.$ReverseControlFCB = addFrameCallback( this.$ReverseControl_FCB );
}

//ReverseControl methods
this.$ReverseControl_FCB = function( delta ) { //FrameCallBack
	var ps = player.ship;
	var r = worldScripts["reversecontrol"];
//	var sn = worldScripts["sniperlock"];
	//player.consoleMessage(ps.AI);//debug
	if( ps && ps.isValid && !ps.docked && ps.viewDirection == "VIEW_AFT" 
		&& ps.AI != "dockingAI.plist" ) { //avoid a clash with Docking Computers
//		if( sn ) sn.deactivate = "TRUE";
		var prevori = r.$ReverseControlPrevOri;
		if( !prevori ) r.$ReverseControlPrevOri = player.ship.orientation;
		else {
			//reverse up-down
			//var a = ps.heading.angleTo( prevori.vectorUp() ) - Math.PI / 2; //buggy with sniperlock
			var a = ps.pitch * delta;
			var c = prevori.vectorRight();
			ps.orientation = ps.orientation.rotate( c, 2 * a );
			//reverse roll
//			var a = ps.orientation.vectorRight().angleTo( prevori.vectorUp() ) - Math.PI / 2; //buggy with sniperlock
			var a = -1 * ps.roll * delta;
			var c = prevori.vectorForward();
			r.$ReverseControlPrevOri = ps.orientation = ps.orientation.rotate( c, -2 * a );
		}
	} else {
//		if( sn ) {
//			if( sn.deactivate != "FALSE" ) {
//				sn.deactivate = "FALSE";
//				sn.shipTargetAcquired();
//			}
//		}
		r.$ReverseControlPrevOri = null;
	}
}